/*
 * Created on 07.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package appfacade;
import domain.*;
import java.util.*;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategoryAttribute implements FacadeAttribute {
	private Phenomenon _actualPhenomenon;
	private PhenomenonType _phenomenonType;
	private PatientDataFacade _facade;
	
	public CategoryAttribute(
		PatientDataFacade facade,
		PhenomenonType phenomenonType
	) {
		_facade = facade;
		_phenomenonType = phenomenonType;
	};
	
	public void load() {
		_actualPhenomenon = _facade.subject().phenomenonOf(_phenomenonType);
	};
	
	public void save() {
		if (_actualPhenomenon == null)
			return;
		new Observation(
			_actualPhenomenon,
			true,
			_facade.subject(),
			_facade.date()
		);
	};

	public String value() {
		return _actualPhenomenon.name();
	};
	
	public void value(String newValue) {
		if (!tableOfValues().containsKey(newValue))
			throw new IllegalArgumentException("Illegal " + _phenomenonType.name());
		_actualPhenomenon = (Phenomenon) tableOfValues().get(newValue);
	};
	
	public Enumeration legalValues() {
		return tableOfValues().keys();
	};
	
	private Hashtable tableOfValues() {
		return _phenomenonType.mappingTable();
	}	
};