/*
 * Created on 07.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package appfacade;
import domain.*;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

class MeasurementAttribute implements FacadeAttribute {
	private PatientDataFacade _facade;
	private PhenomenonType _phenomenonType;
	private Unit _updateUnit;
	private String _value;
	
	public MeasurementAttribute(
		PatientDataFacade facade,
		PhenomenonType phenomenonType,
		Unit updateUnit
	) {
		_facade = facade;
		_phenomenonType = phenomenonType;
		_updateUnit = updateUnit;
	};

	public void load() {
		_value =
			_facade.subject().latestAmountOf(_phenomenonType).amountString();
	};

	public void save() {
		if (_value == null)
			return;
		try {
			new Measurement(
				new Quantity(_value, _updateUnit),
				_phenomenonType,
				_facade.subject(),
				_facade.date());
		} catch (OutOfRangeException e) {
			_value = null;
			return;
		} catch (NumberFormatException e) {
			_value = null;
			return;
		};
	};

	public String name() {
		return _facade.subject().phenomenonOf(_phenomenonType).name();
	};

	public String value() {
		return _value;
	};
	
	public void value(String newValue) {
		_value = (isNumeric(newValue) ? newValue : null);
	};

	private boolean isNumeric(String value) {
		for (int i = 0; i < value.length(); i++) {
			char eachChar = value.charAt(i);
			if (Character.isDigit(eachChar))
				continue;
			if ((i == 0) & (eachChar == '-'))
				continue;
			if (eachChar == '.')
				continue;
			return false;
		};
		return true;
	};
};
