/*
 * Created on 06.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package domain;
import java.util.Date;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Measurement extends Observation {
	private Quantity _amount;
	private PhenomenonType _phenomenonType;

	public Measurement(
		Quantity amount,
		PhenomenonType phenomenonType,
		Patient patient,
		Date whenObserved
	) throws OutOfRangeException {
		if (!phenomenonType.validRangeIncludes(amount))
			throw new OutOfRangeException();
		initialize(patient, whenObserved);
		_amount = amount;
		_phenomenonType = phenomenonType;
		checkInvariant();
		_phenomenon = calculatePhenomenonFor(_amount);
	};

	public Phenomenon calculatePhenomenonFor(Quantity arg) {
		return _phenomenonType.phenomenonIncluding(arg);
	};

	protected void initialize(Patient patient, Date whenObserved) {
		patient.observationsAdd(this);
		_whenObserved = whenObserved;
	};

	private void checkInvariant() {
		assertNonNull(_phenomenonType, "Null phenomenon type");
		assertNonNull(_amount, "Null amount");
	};

	private void assertNonNull(Object object, String errMessage) {
		if (object == null) {
			System.out.println(errMessage);
		}
	};
	
	public Quantity amount() {
		return _amount;
	};
}