/*
 * Created on 06.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package domain;

import java.util.Vector;
import java.util.Enumeration;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Patient extends DomainObject {
	private Vector _observations = new Vector();

	public Patient(String name) {
		super(name);
	};

	public static Patient get(String name) {
		return (Patient) Registrar.get("Patient", name);
	};
	
	public static Enumeration getAll() {
		return Registrar.getNames("Patient");	
	};
	
	public Patient persist() {
		Registrar.add("Patient", this);
		return this;
	};

	public void observationsAdd(Observation newObs) {
		_observations.addElement(newObs);
	};

	public Phenomenon phenomenonOf(String name) {
		return phenomenonOf(PhenomenonType.get(name));
	};

	public Phenomenon phenomenonOf(PhenomenonType phenomenonType) {
		return (
			latestObservation(phenomenonType) == null
				? new NullPhenomenon()
				: latestObservation(phenomenonType).phenomenon());
	};

	public Enumeration observationsOf(PhenomenonType value) {
		Vector result = new Vector();
		Enumeration e = observations();
		while (e.hasMoreElements()) {
			Observation each = (Observation) e.nextElement();
			if (each.phenomenonType() == value)
				result.addElement(each);
		};
		return result.elements();
	};
	
	public Enumeration observationsOf(Phenomenon value) {
		Vector result = new Vector();
		Enumeration e = observations();
		while (e.hasMoreElements()) {
			Observation each = (Observation) e.nextElement();
			if (each.phenomenon() == value)
				result.addElement(each);
		};
		return result.elements();
	};
	
	public Boolean isPresent(Phenomenon value) {
		return (
			latestObservation(value) == null
				? null
				: new Boolean(latestObservation(value).isPresent()));
	};
	
	public Enumeration observations() {
		return _observations.elements();
	};
	
	public Observation latestObservation(PhenomenonType value) {
		return latestObservationIn(observationsOf(value));
	};
	
	public Quantity latestAmountOf(PhenomenonType value) {
		Measurement latestMeasurement = 
			(Measurement) latestObservationIn(observationsOf(value));
		return (
			latestMeasurement == null ?
				new NullQuantity() :
				latestMeasurement.amount()
		);
	};
	
	public Observation latestObservation(Phenomenon value) {
		return latestObservationIn(observationsOf(value));
	};

	private Observation latestObservationIn(Enumeration observationEnum) {
		if (!observationEnum.hasMoreElements())
			return null;
		Observation result = (Observation) observationEnum.nextElement();
		if (!observationEnum.hasMoreElements())
			return result;
		do {
			Observation each = (Observation) observationEnum.nextElement();
			if (each.whenObserved().after(result.whenObserved()))
				result = each;
		} while (observationEnum.hasMoreElements());
		return result;
	};
}
