/*
 * Created on 06.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package domain;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Quantity {
	private double _amount;
	private Unit _unit;

	public Quantity() {
		_amount = 0;
	};
	
	public Quantity(double amount, Unit unit) {
		requireNonNull(unit);
		_amount = amount;
		_unit = unit;
	};

	public Quantity(String amountString, Unit unit) {
		this(new Double(amountString).doubleValue(), unit);
	};

	public Quantity(int amount, Unit unit) {
		this(new Double(amount).doubleValue(), unit);
	};

	protected void requireNonNull(Object arg) {
		if (arg == null)
			throw new NullPointerException();
	};

	public String amountString() {
		if (_amount - Math.floor(_amount) == 0.0) {
			return String.valueOf( new Double(_amount).intValue());
		}
		else 		
			return String.valueOf(_amount);
	};
	
	public Unit unit() {
		return _unit;	
	};

	public double amount() {
		 return _amount;
	};
	
	public boolean equals(Quantity arg) {
		return _unit.equals(arg.unit()) && (_amount == arg.amount());
	};
	public boolean isLessThan(Quantity arg) {
		requireSameUnitsAs(arg);
		return _amount < arg.amount();
	};
	public boolean isLessThanOrEqualTo(Quantity arg) {
		requireSameUnitsAs(arg);
		return isLessThan(arg) || equals(arg);
	};
	public boolean isGreaterThan(Quantity arg) {
		requireSameUnitsAs(arg);
		return !isLessThanOrEqualTo(arg);
	};
	public boolean isGreaterThanOrEqualTo(Quantity arg) {
		requireSameUnitsAs(arg);
		return !isLessThan(arg);
	};
	private void requireSameUnitsAs(Quantity arg) {
		if (!_unit.equals(arg.unit()))
			throw new IllegalArgumentException();
	};
};
