/*
 * Created on 07.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package domain;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class QuantityRange {
	private Quantity _start;
	private Quantity _end;
	private boolean _isStartInclusive;
	private boolean _isEndInclusive;

	public QuantityRange(
		Quantity start,
		boolean isStartInclusive,
		Quantity end,
		boolean isEndInclusive) {
		_start = start;
		// null implies no lower bound
		_end = end;
		//null implies no upper bound
		_isStartInclusive = isStartInclusive;
		_isEndInclusive = isEndInclusive;
	};
	public QuantityRange(Quantity start, Quantity end) {
		this(start, true, end, true);
	};
	public static QuantityRange unlimited() {
		return new QuantityRange(null, null);
	};

	public boolean includes(Quantity value) {
		if (_end != null) {
			if (value.isGreaterThan(_end))
				return false;
			if (!_isEndInclusive && value.equals(_end))
				return false;
		};
		if (_start != null) {
			if (value.isLessThan(_start))
				return false;
			if (!_isStartInclusive && value.equals(_start))
				return false;
		};
		return true;
	};

	public static void main() {
		String result = "";
		Unit cm = new Unit("cm");
		QuantityRange range1 =
			new QuantityRange(new Quantity(100, cm), new Quantity(200, cm));
		if (range1.includes(new Quantity(201, cm)))
			result += "201 within range\n";
		if (range1.includes(new Quantity(200.0001, cm)))
			result += "200.0001 within range\n";
		if (!range1.includes(new Quantity(200, cm)))
			result += "200 not within range\n";
		if (!range1.includes(new Quantity(199, cm)))
			result += "199 not within range\n";
		if (!range1.includes(new Quantity(101, cm)))
			result += "101 not within range\n";
		if (!range1.includes(new Quantity(100, cm)))
			result += "100 not within range\n";
		if (range1.includes(new Quantity(99.999, cm)))
			result += "99.999 within range\n";
		if (range1.includes(new Quantity(99, cm)))
			result += "99 within range\n";
		QuantityRange range2 =
			new QuantityRange(
				new Quantity(250, cm),
				false,
				new Quantity(400, cm),
				false);
		if (range2.includes(new Quantity(249.99, cm)))
			result += "249.99 within range\n";
		if (range2.includes(new Quantity(250, cm)))
			result += "250 within range\n";
		if (!range2.includes(new Quantity(250.0001, cm)))
			result += "250.0001 not within range\n";
		if (!range2.includes(new Quantity(399.9999, cm)))
			result += "399.9999 not within range\n";
		if (range2.includes(new Quantity(400, cm)))
			result += "400 within range\n";
		if (range2.includes(new Quantity(400.0001, cm)))
			result += "400.0001 within range\n";
		if (range2.includes(new Quantity(401, cm)))
			result += "401 within range\n";
		if (result == "")
			result = "OK";
		System.out.println(result);
	};
}
