/*
 * Created on 06.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package domain;
import java.util.*;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Registrar {
	private static Registrar _soleInstance = new Registrar();
	private Dictionary _entryPoints = new Hashtable();

	private void assertNonNull(Object arg, String message) throws NullPointerException {
		if (arg == null)
			throw new NullPointerException(message);
	};

	public static void add(String entryPoint, DomainObject newObject) {
		_soleInstance.addObj(entryPoint, newObject);
	};

	public static DomainObject get(String entryPointName, String objectName) {
		return _soleInstance.getObj(entryPointName, objectName);
	};

	private void addObj(String entryPointName, DomainObject newObject) {
		Dictionary theEntryPoint =
			(Dictionary) _entryPoints.get(entryPointName);
		if (theEntryPoint == null) {
			theEntryPoint = new Hashtable();
			_entryPoints.put(entryPointName, theEntryPoint);
		};
		theEntryPoint.put(newObject.name(), newObject);
	};

	private DomainObject getObj(String entryPointName, String objectName) {
		Dictionary theEntryPoint =
			(Dictionary) _entryPoints.get(entryPointName);
		try {
			assertNonNull(
				theEntryPoint,
				"No entry point present for " + entryPointName);
		}
		catch (NullPointerException e) {
			return null;
		}
		DomainObject answer = (DomainObject) theEntryPoint.get(objectName);
		try {
			assertNonNull(
				answer,
				"There is no " + entryPointName + " called " + objectName);
		}
		catch (NullPointerException e) {
			return null;
		}
		return answer;
	};

	public static Enumeration getNames(String entryPointName) {
		return _soleInstance.getObjNames(entryPointName);
	};

	private Enumeration getObjNames(String entryPointName) {
		Dictionary theEntryPoint =
			(Dictionary) _entryPoints.get(entryPointName);
		assertNonNull(
			theEntryPoint,
			"No entry point present for " + entryPointName
		);
		// an existing entry point with name entryPointName means it has 
		// at least one key/value pair, so no more assertNonNull() needed here.
		return theEntryPoint.keys(); 
	};
};