/*
 * Created on 07.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package presentation;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;

import appfacade.PatientDataFacade;

/**
 * @author matthias & Babak
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

class RecordPatientWindow extends JFrame implements ActionListener {

	private PatientDataFacade _facade;
	private JTabbedPane tabbedPane = new JTabbedPane();
	private JTextField 	breathingRate = new JTextField();
	private JTextField 	heartRate = new JTextField();
	private JTextField 	temperature = new JTextField();
	private JComboBox 	levelOfConsciousness = new JComboBox();
	private JComboBox 	bloodgroup = new JComboBox();
	private JComboBox	listpatients = new JComboBox();
	//private JButton 		showbutton = new JButton("Show Patient Datas");
	private JButton 		recordButton = new JButton("Record Patient Data");
	private JButton 		resetButton = new JButton("Reset");
	private JTextField 	name = new JTextField("", 10);
	// Show Patient Datas
	//private JTextField 	sname = new JTextField();
	private JLabel 			sbreathing = new JLabel();
	private JLabel 			sheart = new JLabel();
	private JLabel 			stemper = new JLabel();
	private JLabel 			slevelofc = new JLabel();
	private JLabel 			sbloodg = new JLabel();
	private JLabel 			nopatient = new JLabel();

	public RecordPatientWindow(PatientDataFacade facade) {
		
		_facade = facade;
		loadChoices(); 
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(tabbedPane);
		setTitle("Patient Datas: ");
		
		tabbedPane.addTab("Record Patient Data", buildRecordPanel());
		tabbedPane.setSelectedIndex(0);
		tabbedPane.addTab("Show Patient Data", buildShowPanel());
		resetButton.addActionListener(this);
		recordButton.addActionListener(this);
		listpatients.addActionListener(this);
		
		WindowAdapter wl = new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		};
		addWindowListener(wl);
		setSize(430, 300);
		this.pack();
	};
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == resetButton) {
			name.setText("");
			breathingRate.setText("");
			heartRate.setText("");
			temperature.setText("");
		}
		
		if (e.getSource() == recordButton) {
			
			//new Patient(name.getText()).persist(); done in facade
			_facade.subject(name.getText());
			//patientsrecorded.put(name.getText(), _facade.subject());
			_facade.breathingRate(breathingRate.getText());
			_facade.heartRate(heartRate.getText());
			_facade.temperature(temperature.getText());
			_facade.levelOfConsciousness(
				levelOfConsciousness.getSelectedItem());
			_facade.bloodGroup(bloodgroup.getSelectedItem().toString());
			_facade.save();
			
			deletelistOfPatients();
			loadlistOfPatients();
			listpatients.setSelectedItem(_facade.name());
			tabbedPane.setSelectedIndex(1);
		}
		
		if (e.getSource() == listpatients) {
			if ((_facade.subject() == null) || (listpatients.getSelectedItem() == null)) {
				nopatient.setText("No patient yet.");
			} else {
				_facade.subject((String) listpatients.getSelectedItem());
				_facade.load();
				nopatient.setText("");
				sbreathing.setText(_facade.breathingRate());
				sheart.setText(_facade.heartRate());
				stemper.setText(_facade.temperature());
				slevelofc.setText(_facade.levelOfConsciousness());
				sbloodg.setText(_facade.bloodGroup());
			}
		}
	}

	private void showpatientdatas (Object name)
	{
		Enumeration patients = _facade.getLegalSubjects();
		while (patients.hasMoreElements())
		{
				_facade.subject ( patients.nextElement().toString());
				sbreathing.setText(_facade.breathingRate());
				sheart.setText(_facade.heartRate());
				stemper.setText(_facade.temperature());
				slevelofc.setText(_facade.levelOfConsciousness());
				sbloodg.setText(_facade.bloodGroup());
			
		}
	};
	private JPanel buildRecordPanel() {
		JPanel recpanel = new JPanel(new BorderLayout());
		recpanel.add("North", namePanel());
		recpanel.add("Center", readingsPanel());
		recpanel.add("South", buttonsPanel());

		return recpanel;
	}
	private JPanel buildShowPanel() {
		JLabel name = new JLabel("Name:");
		JLabel breathing = new JLabel("Breathing Rate per min:");
		JLabel heart = new JLabel("Heart Rate per min:");
		JLabel temper = new JLabel("Teperature:");
		JLabel levelofc = new JLabel("Level of Consciousness:");
		JLabel bloodg = new JLabel("Blood Group:");
		JPanel showpanel = new JPanel();

		showpanel.setLayout(new GridLayout(10, 2));
		showpanel.add(name);
		showpanel.add(listpatients);
		showpanel.add(breathing);
		showpanel.add(sbreathing);
		showpanel.add(heart);
		showpanel.add(sheart);
		showpanel.add(temper);
		showpanel.add(stemper);
		showpanel.add(levelofc);
		showpanel.add(slevelofc);
		showpanel.add(bloodg);
		showpanel.add(sbloodg);
		showpanel.add(new JLabel());
		showpanel.add(new JLabel());
		showpanel.add (new JLabel());
		showpanel.add(nopatient);
		
		return showpanel;

	}

	private void loadChoices() {
		loadLevelOfConsciousnessChoices();
		loadBloodGroupChoices();
	};

	private void loadLevelOfConsciousnessChoices() {
		Enumeration consciousnessValues = _facade.levelOfConsciousnessValues();
		while (consciousnessValues.hasMoreElements()) {
			levelOfConsciousness.addItem(
				(String) consciousnessValues.nextElement());
		}
	}

	private void loadBloodGroupChoices() {
		Enumeration bloodgroupValues = _facade.bloodGroupValues();
		while (bloodgroupValues.hasMoreElements()) {
			bloodgroup.addItem((String) bloodgroupValues.nextElement());
		};
	};

	private void loadlistOfPatients()
	{
		Enumeration patients = _facade.getLegalSubjects();
		if(patients != null) {
			/* no action listening during item insertion, as every item causes an 
			 * event to be fired. */ 
			listpatients.removeActionListener(this);
			while (patients.hasMoreElements()){
				listpatients.addItem((String) patients.nextElement());
			}
			listpatients.addActionListener(this);
		}
		
	}	
	
	private void deletelistOfPatients()
	{
				listpatients.removeAllItems();
	}
	
	private JPanel namePanel() {
		JPanel newPanel = new JPanel();
		JLabel nameLabel = new JLabel("Name");
		JLabel dummyLabel = new JLabel("");

		newPanel.setLayout(new GridLayout(0, 2, 10, 10));
		newPanel.add(name);
		newPanel.add(nameLabel);
		newPanel.add(dummyLabel);
		return newPanel;
	};

	private JPanel readingsPanel() {
		JPanel newPanel = new JPanel();
		newPanel.setLayout(new GridLayout(0, 2, 3, 3));
		levelOfConsciousness.setEnabled(true);

		bloodgroup.setEnabled(true);
		newPanel.add(breathingRate);
		newPanel.add(new JLabel("Breathing Rate/ min "));
		newPanel.add(heartRate);
		newPanel.add(new JLabel("Heart Rate/min "));
		newPanel.add(temperature);
		newPanel.add(new JLabel("Temperature/Degree Celsius"));
		newPanel.add(levelOfConsciousness);
		newPanel.add(new JLabel("Level of Consciousness"));
		newPanel.add(bloodgroup);
		newPanel.add(new JLabel("Blood Group"));
		newPanel.add(new JLabel(""));
		newPanel.add(new JLabel(""));
		newPanel.add(new JLabel(""));
		return newPanel;
	};

	private JPanel buttonsPanel() {
		JPanel newPanel = new JPanel();
		recordButton.setBackground(Color.green);
		newPanel.add(recordButton);
		newPanel.add(resetButton);
		return newPanel;
	};

	private void resetAction() {
		System.exit(0);
	};

	public static void main(String[] args) {
		PatientDataFacade.setupObservationToolkit();
		PatientDataFacade facade = new PatientDataFacade();
		JFrame frame = new RecordPatientWindow(facade);
		//center the frame
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = frame.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		frame.setLocation(
			(screenSize.width - frameSize.width) / 2,
			(screenSize.height - frameSize.height) / 2);
		frame.setVisible(true);
	}
};