/*
 * Created on 06.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package testing;

import java.util.*;
import domain.*;
import appfacade.*;
import junit.framework.TestCase;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class PatientDataFacadeTest extends TestCase {
	
	PatientDataFacade _facade;
	
	public PatientDataFacadeTest(String arg0) {
		super(arg0);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		PatientDataFacade.setupObservationToolkit();
		new Patient("Adams").persist();
		
		_facade = new PatientDataFacade();
		_facade.subject("Adams");

		//observation of gender at 1996-03-01 not possible via GUI, therefore directly:
		new Observation(
			PhenomenonType.get("gender").phenomenonNamed("male"),
			true,
			Patient.get("Adams"),
			new GregorianCalendar(1996, 3, 1).getTime()
		);
		
		//set of observations from 1996-03-01 04:00h
		_facade.date( new GregorianCalendar(1996, 3, 1, 4, 0).getTime() );
		_facade.breathingRate("13");
		_facade.heartRate("92");
		_facade.temperature("37.7");
		_facade.levelOfConsciousness("pain");
		_facade.bloodGroup("AB");
		_facade.save();
		
		// set of observations from 196-03-01 06:00h
		_facade.date(new GregorianCalendar(1996, 3, 1, 6, 0).getTime() );
		_facade.breathingRate("10");
		_facade.heartRate("87");
		_facade.temperature("36.3");
		_facade.levelOfConsciousness("verbal");
		_facade.bloodGroup("0");
		_facade.save();
	}
	
	public void testPhenomena() {
		try {
			PatientDataFacade facade = new PatientDataFacade();
			facade.subject("Adams");
			facade.load();
			
			assertEquals("Adams without name", "Adams", facade.name());
			assertEquals("Adams not male", "male", facade.gender());
			assertNotNull("breathing rate is null", facade.breathingRate());
			assertEquals("incorrect breathing rate", "10", facade.breathingRate());
			assertNotNull("heart rate is null", facade.heartRate());
			assertEquals("incorrect heart rate", "87", facade.heartRate());
			assertNotNull("temperature is null", facade.temperature());
			assertEquals("incorrect temperature", "36.3", facade.temperature());
			assertEquals("Adams not verbal", "verbal", facade.levelOfConsciousness());
			assertEquals("incorrect blood group", "0", facade.bloodGroup());
		} catch (Exception e) {
			String message = "Exception " + e.toString();
			if (e.getMessage() != null)
				message += " " + e.getMessage();
			System.out.println(message);
			e.printStackTrace();
			fail();
		};
	};
	
	public void testLegalSubjects() {
		new Patient("Bdams").persist();
		new Patient("Cdams").persist();
		new Patient("Ddams").persist();
		new Patient("Edams").persist();
		
		Enumeration legalSubjects = _facade.getLegalSubjects();
		int i = 0;
		while (legalSubjects.hasMoreElements()) {
			String each = (String) legalSubjects.nextElement();
			++i;
			try {
				assertNotNull(each + "is no legal subject", Registrar.get("Patient", each) );
			}
			catch (NullPointerException e) {
				fail(each + "is no legal subject");
			}
		};
		assertEquals("getLegalSubjects returned not 5 subjects", 5, i);
	};

};
