/*
 * Created on 20.12.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package testing;

import junit.framework.TestCase;
import domain.*;

/**
 * @author matthias
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PhenomenonTypeTest extends TestCase {

	/**
	 * Constructor for PhenomenonTest.
	 * @param name
	 */
	public PhenomenonTypeTest(String name) {
		super(name);
	};

	protected void setUp() throws Exception {
		PhenomenonType a = new PhenomenonType("a").persist();
		String[] a_Phenomena = { "a_a", "a_b", "a_c" };
		a.setPhenomena(a_Phenomena);

		PhenomenonType b = new PhenomenonType("b").persist();
		new Phenomenon("b_a", b);
		new Phenomenon("b_b", b);
		new Phenomenon("b_c", b);

		Unit c_unit = new Unit("c_unit").persist();
		PhenomenonType c = new PhenomenonType("c").persist();
		new Phenomenon("c_a (x<9)", c).range(
			new QuantityRange(null, false, new Quantity(9, c_unit), false));
		new Phenomenon("c_b (9<x<19)", c).range(
			new QuantityRange(
				new Quantity(9, c_unit),
				new Quantity(19, c_unit)));
		new Phenomenon("c_c (19<x)", c).range(
			new QuantityRange(new Quantity(19, c_unit), false, null, false));
	};

	protected void tearDown() throws Exception {
	};

	public void test_a() {
		PhenomenonType a =
			(PhenomenonType) Registrar.get("PhenomenonType", "a");
		assertTrue(
			"a_a no Phenomenon of a",
			a.mappingTable().keySet().contains("a_a"));
		assertTrue(
			"a_b no Phenomenon of a",
			a.mappingTable().keySet().contains("a_b"));
		assertTrue(
			"a_c no Phenomenon of a",
			a.mappingTable().keySet().contains("a_c"));
		assertTrue(
			"incorrect number of elements in a",
			a.mappingTable().keySet().size() == 3);
	};

	public void test_b() {
		PhenomenonType b =
			(PhenomenonType) Registrar.get("PhenomenonType", "b");
		assertNotNull("b_a no Phenomenon of b", b.phenomenonNamed("b_a"));
		assertNotNull("b_b no Phenomenon of b", b.phenomenonNamed("b_b"));
		assertNotNull("b_c no Phenomenon of b", b.phenomenonNamed("b_c"));
		assertTrue(
			"incorrect number of elements in b",
			b.mappingTable().keySet().size() == 3);
	};

	public void test_c() {
		PhenomenonType c =
			(PhenomenonType) Registrar.get("PhenomenonType", "c");
		Unit c_unit = (Unit) Registrar.get("Unit", "c_unit");
		assertEquals(
			"c_a not corresponding to 5 c_unit in c",
			c.phenomenonNamed("c_a (x<9)"),
			c.phenomenonIncluding(new Quantity(5.0, c_unit))
		);
		assertEquals(
			"c_b not corresponding to 10 c_unit in c",
			c.phenomenonNamed("c_b (9<x<19)"),
			c.phenomenonIncluding(new Quantity(10.0, c_unit))
		);
		assertEquals(
			"c_c not corresponding to 100.0 c_unit in c",
			c.phenomenonNamed("c_c (19<x)"),
			c.phenomenonIncluding(new Quantity(100.0, c_unit)));
	};
}
